#define TWO_WAY
#undef DECAL_FEEDBACK

MODULE agrif_top_update
   !!======================================================================
   !!                ***  MODULE agrif_top_update  ***
   !! AGRIF :   
   !!----------------------------------------------------------------------
   !! History :  
   !!----------------------------------------------------------------------

#if defined key_agrif && defined key_top
   USE par_oce
   USE oce
   USE par_trc
   USE trc
   USE dom_oce
   USE agrif_oce
   USE wrk_nemo  

   IMPLICIT NONE
   PRIVATE

   PUBLIC Agrif_Update_Trc

   INTEGER, PUBLIC ::   nbcline_trc = 0   !: ???

   !!----------------------------------------------------------------------
   !! NEMO/NST 3.7 , NEMO Consortium (2015)
   !! $Id$
   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
   !!----------------------------------------------------------------------
CONTAINS

   SUBROUTINE Agrif_Update_Trc( )
      !!----------------------------------------------------------------------
      !!                   *** ROUTINE Agrif_Update_Trc ***
      !!----------------------------------------------------------------------
      ! 
      IF (Agrif_Root()) RETURN 
      !
#if defined TWO_WAY   
      Agrif_UseSpecialValueInUpdate = .TRUE.
      Agrif_SpecialValueFineGrid    = 0._wp
      ! 
      IF( MOD(nbcline_trc,nbclineupdate) == 0 ) THEN
# if ! defined DECAL_FEEDBACK
         CALL Agrif_Update_Variable(trn_id, procname=updateTRC )
# else
         CALL Agrif_Update_Variable(trn_id, locupdate=(/1,0/),procname=updateTRC )
# endif
      ELSE
# if ! defined DECAL_FEEDBACK
         CALL Agrif_Update_Variable( trn_id, locupdate=(/0,2/), procname=updateTRC )
# else
         CALL Agrif_Update_Variable( trn_id, locupdate=(/1,2/), procname=updateTRC )
# endif
      ENDIF
      !
      Agrif_UseSpecialValueInUpdate = .FALSE.
      nbcline_trc = nbcline_trc + 1
#endif
      !
   END SUBROUTINE Agrif_Update_Trc


   SUBROUTINE updateTRC( ptab, i1, i2, j1, j2, k1, k2, n1, n2, before, nb, ndir )
      !!----------------------------------------------------------------------
      !!                      *** ROUTINE updateT ***
      !!----------------------------------------------------------------------
      INTEGER                                    , INTENT(in   ) ::   i1, i2, j1, j2, k1, k2, n1, n2
      REAL(wp),DIMENSION(i1:i2,j1:j2,k1:k2,n1:n2), INTENT(inout) ::   ptab
      LOGICAL                                    , INTENT(in   ) ::   before
      INTEGER, INTENT(in) :: nb, ndir
      !!
      LOGICAL :: western_side, eastern_side, southern_side, northern_side 
      INTEGER :: ji,jj,jk,jn
      REAL(wp) :: ztb, ztnu, ztno
      !!----------------------------------------------------------------------
      !
      !
      IF (before) THEN
         DO jn = n1,n2
            DO jk=k1,k2
               DO jj=j1,j2
                  DO ji=i1,i2
!> jc tmp
                     tabres(ji,jj,jk,jn) = trn(ji,jj,jk,jn)  * e3t_n(ji,jj,jk) / e3t_0(ji,jj,jk)
!                     tabres(ji,jj,jk,jn) = trn(ji,jj,jk,jn)  * e3t_n(ji,jj,jk)
!< jc tmp
                  END DO
               END DO
            END DO
         END DO
      ELSE
!> jc tmp
         DO jn = n1,n2
            tabres(i1:i2,j1:j2,k1:k2,jn) =  tabres(i1:i2,j1:j2,k1:k2,jn) * e3t_0(i1:i2,j1:j2,k1:k2) &
                                         & * tmask(i1:i2,j1:j2,k1:k2)
         ENDDO
!< jc tmp
         IF (.NOT.(lk_agrif_fstep.AND.(neuler==0))) THEN
            ! Add asselin part
            DO jn = n1,n2
               DO jk=k1,k2
                  DO jj=j1,j2
                     DO ji=i1,i2
                        IF( tabres(ji,jj,jk,jn) .NE. 0. ) THEN
                           ztb  = trb(ji,jj,jk,jn) * e3t_b(ji,jj,jk) ! fse3t_b prior update should be used
                           ztnu = tabres(ji,jj,jk,jn)
                           ztno = trn(ji,jj,jk,jn) * e3t_a(ji,jj,jk)
                           trb(ji,jj,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
                                     &        * tmask(ji,jj,jk) / e3t_b(ji,jj,jk)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
         DO jn = n1,n2
            DO jk=k1,k2
               DO jj=j1,j2
                  DO ji=i1,i2
                     IF( tabres(ji,jj,jk,jn) .NE. 0. ) THEN 
                        trn(ji,jj,jk,jn) = tabres(ji,jj,jk,jn) / e3t_n(ji,jj,jk)
                     END IF
                  END DO
               END DO
            END DO
         END DO
         !
         IF  ((neuler==0).AND.(Agrif_Nb_Step()==0) ) THEN
            trb(i1:i2,j1:j2,k1:k2,n1:n2)  = trn(i1:i2,j1:j2,k1:k2,n1:n2)
         ENDIF
         !
         !
# if defined DECAL_FEEDBACK
         IF (.NOT.ln_linssh) THEN 
            western_side  = (nb == 1).AND.(ndir == 1)
            eastern_side  = (nb == 1).AND.(ndir == 2)
            southern_side = (nb == 2).AND.(ndir == 1)
            northern_side = (nb == 2).AND.(ndir == 2)
            !
            ! Asselin correction 
            IF (.NOT.(lk_agrif_fstep.AND.(neuler==0))) THEN
               IF (southern_side) THEN
                  DO jn = n1,n2
                     DO jk=k1,k2
                        DO ji=i1,i2
                           ztb  = trb(ji,j1-1,jk,jn) * e3t_b(ji,j1-1,jk) ! fse3t_b prior update should be used
                           ztnu = trn(ji,j1-1,jk,jn) * e3t_n(ji,j1-1,jk)
                           ztno = trn(ji,j1-1,jk,jn) * e3t_a(ji,j1-1,jk)
                           trb(ji,j1-1,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
                                     &        * tmask(ji,j1-1,jk) / e3t_b(ji,j1-1,jk)
                        END DO
                     ENDDO
                  ENDDO
               ENDIF
               IF (northern_side) THEN
                  DO jn = n1,n2
                     DO jk=k1,k2
                        DO ji=i1,i2
                           ztb  = trb(ji,j2+1,jk,jn) * e3t_b(ji,j2+1,jk) ! fse3t_b prior update should be used
                           ztnu = trn(ji,j2+1,jk,jn) * e3t_n(ji,j2+1,jk)
                           ztno = trn(ji,j2+1,jk,jn) * e3t_a(ji,j2+1,jk)
                           trb(ji,j2+1,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
                                     &        * tmask(ji,j2+1,jk) / e3t_b(ji,j2+1,jk)
                        END DO
                     ENDDO
                  ENDDO
               ENDIF
               IF (western_side) THEN
                  DO jn = n1,n2
                     DO jk=k1,k2
                        DO jj=j1,j2
                           ztb  = trb(i1-1,jj,jk,jn) * e3t_b(i1-1,jj,jk) ! fse3t_b prior update should be used
                           ztnu = trn(i1-1,jj,jk,jn) * e3t_n(i1-1,jj,jk)
                           ztno = trn(i1-1,jj,jk,jn) * e3t_a(i1-1,jj,jk)
                           trb(i1-1,jj,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
                                     &        * tmask(i1-1,jj,jk) / e3t_b(i1-1,jj,jk)
                        END DO
                     ENDDO
                  ENDDO
               ENDIF
               IF (eastern_side) THEN
                  DO jn = n1,n2
                     DO jk=k1,k2
                        DO jj=j1,j2
                           ztb  = trb(i2+1,jj,jk,jn) * e3t_b(i2+1,jj,jk) ! fse3t_b prior update should be used
                           ztnu = trn(i2+1,jj,jk,jn) * e3t_n(i2+1,jj,jk)
                           ztno = trn(i2+1,jj,jk,jn) * e3t_a(i2+1,jj,jk)
                           trb(i2+1,jj,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
                                     &        * tmask(i2+1,jj,jk) / e3t_b(i2+1,jj,jk)
                        END DO
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF ! Asselin correction

            IF (southern_side) THEN
               DO jn = n1,n2
                  DO jk=k1,k2
                     DO ji=i1,i2
                        trn(ji,j1-1,jk,jn) = trn(ji,j1-1,jk,jn) * e3t_a(ji,j1-1,jk) / e3t_n(ji,j1-1,jk)
                     END DO
                  ENDDO
               ENDDO
            ENDIF
            IF (northern_side) THEN
               DO jn = n1,n2
                  DO jk=k1,k2
                     DO ji=i1,i2
                        trn(ji,j2+1,jk,jn) = trn(ji,j2+1,jk,jn) * e3t_a(ji,j2+1,jk) / e3t_n(ji,j2+1,jk)
                     END DO
                  ENDDO
               ENDDO
            ENDIF
            IF (western_side) THEN
               DO jn = n1,n2
                  DO jk=k1,k2
                     DO jj=j1,j2
                        trn(i1-1,jj,jk,jn) = trn(i1-1,jj,jk,jn) * e3t_a(i1-1,jj,jk) / e3t_n(i1-1,jj,jk)
                     END DO
                  ENDDO
               ENDDO
            ENDIF
            IF (eastern_side) THEN
               DO jn = n1,n2
                  DO jk=k1,k2
                     DO jj=j1,j2
                        trn(i2+1,jj,jk,jn) = trn(i2+1,jj,jk,jn) * e3t_a(i2+1,jj,jk) / e3t_n(i2+1,jj,jk)
                     END DO
                  ENDDO
               ENDDO
            ENDIF
         ENDIF
#endif
      ENDIF
      ! 
   END SUBROUTINE updateTRC

#else
CONTAINS
   SUBROUTINE agrif_top_update_empty
      !!---------------------------------------------
      !!   *** ROUTINE agrif_Top_update_empty ***
      !!---------------------------------------------
      WRITE(*,*)  'agrif_top_update : You should not have seen this print! error?'
   END SUBROUTINE agrif_top_update_empty
#endif

   !!======================================================================
END MODULE agrif_top_update
